12_08_01.onleavecontext {
	sta		= int(wordat(sstring, 0));	stamax		= int(wordat(sstring, 1));
	effstr	= int(wordat(sstring, 2));	str			= int(wordat(sstring, 3));
	effdex	= int(wordat(sstring, 4));	dex			= int(wordat(sstring, 5));
	mag		= int(wordat(sstring, 6));	magmax		= int(wordat(sstring, 7));
	score	= wordat(sstring, 8);		blind		= wordat(sstring, 9);
	deaf	= wordat(sstring, 10);		crippled	= wordat(sstring, 11);
	dumb	= wordat(sstring, 12);		ttreset		= int(wordat(sstring, 13));
	weather	= wordat(sstring, 14);

	updatestatus();
	popoutput();
}

enterinfo {
	if (context == '12')
	{
		infotext = '';

		if (pendinginfo > 0)
			{ pushoutput(''); }									
	};
}

oninfotext {
	if (context == '12')
		{ infotext += text; };
}

leaveinfo {
	if (context == '12')
	{					
		# Extract useful information here... #
		
		if ((infotext ~= 'alive') && (infotext ~= 'dead'))
		{											
			# Test for survivor information... #
			
			if (words(infotext) == 4)
			{												
				oldsurvivors = survivors;
				# split(survivors, null, mobkilled, null, infotext); #

				survivors = int(wordat(infotext, 0));
				mobkilled = int(wordat(infotext, 2));

				if (oldsurvivors != survivors)
				{		
					# Update survivors display... #					

					if (isvisible('infopane'))
					{
						settext('survivors', (string(survivors) + ' / ') + (mobkilled + survivors));	
						update('survivors');
					}
				}
			}
		}

		if (pendinginfo > 0)
		{
			pendinginfo--;
			popoutput();						

			# A new line is sent after this context ends, so suppress it #
						
			suppresscr();
		}										
	};
}

disenableteam {
	# -- FETEAM function ------------------------- #

	if (teamed == 0)
	{ 
		disablewindow('check_team');
		hidewindow('teampane');

		unauto('feteam');
	}
	else						
	{
		enablewindow('check_team');
		auto('feteam', 15, 'sendinterrupt(\'feteam\');');
	};
}

setteaminfo {
	# -- FETEAM function ------------------------- #

	if ((words(fetinfo)) < 4)
	{							
		# Not in a team, so cancel team info requests #

		teamed = 0;
		disenableteam();
	}
	else
	{
		# Get team number, kills, score and captain #
			
		tmno = (wordat(fetinfo, 0));						
		tmkills = (wordat(fetinfo, 1));						
		tmscore = (wordat(fetinfo, 2));						
		tmcaptain = (wordat(fetinfo, 3));
							
		# Extract respawn room (comes after '|') #

		restartoffset = (find(fetinfo, '| '));
		settext('teamstart', (substr(fetinfo, (restartoffset + 2), 255)));					
							
		# Calculate member count #

		tmmembers = (((words(fetinfo)) - (words(gettext('teamstart')))) - 5);
		settext('teammembers', tmmembers);

		settext('team', tmno);
		settext('teamscore', (((('' + tmscore) + ' (') + tmkills) + ')'));
		settext('teamcaptain', tmcaptain);
	};
}

updateplayercount {
	# -- FEWHO function (player count) --------- #

	if (playercount != oldplayercount)
	{							
		settext('players', playercount);
		update('players');

		oldplayercount = playercount;
	};
}

processmapline {
	# -- FEMAP function ------------------------ #

	if (mapline == 1)
	{
		# split(mapup, maptext); #
		mapup = wordat(maptext, 0);

		mapicon = mapup; iconid = 'map_up'; setmapicon();
	}

	if (mapline == 3)
	{
		# split(mapnw, mapn, mapne, maptext); #
		mapnw = wordat(maptext, 0);
		mapn = wordat(maptext, 1);
		mapne = wordat(maptext, 2);

		mapicon = mapnw; iconid = 'map_nw'; setmapicon();
		mapicon = mapn; iconid = 'map_n'; setmapicon();
		mapicon = mapne; iconid = 'map_ne'; setmapicon();
	}

	if (mapline == 5)
	{
		# split(mapw, mape, maptext); #
		mapw = wordat(maptext, 0);
		mape = wordat(maptext, 1);

		mapicon = mapw; iconid = 'map_w'; setmapicon();							
		mapicon = mape; iconid = 'map_e'; setmapicon();
	}

	if (mapline == 7)
	{
		# split(mapsw, maps, mapse, maptext); #
		mapsw = wordat(maptext, 0);
		maps = wordat(maptext, 1);
		mapse = wordat(maptext, 2);

		mapicon = mapsw; iconid = 'map_sw'; setmapicon();
		mapicon = maps; iconid = 'map_s'; setmapicon();
		mapicon = mapse; iconid = 'map_se'; setmapicon();
	}

	if (mapline == 9)
	{
		# split(mapdown, maptext); #
		mapdown = wordat(maptext, 0);

		mapicon = mapdown; iconid = 'map_down'; setmapicon();
	}

	maptext = '';
	mapline++;
}

setmapicon {
	# -- FEMAP function ------------------------ #

	imageid = 'map_dunno';
	imageid = switch(mapicon, '## => map_wall,	   ~. => map_beach,
							   == => map_bed,	   +  => map_crypt,
							   oo => map_dark,	   /  => map_none,
							   ?? => map_dunno,	   {} => map_garden,
							   ++ => map_grave,	   .^ => map_hill,
							   __ => map_meadow,   o  => map_fring,
							   ^^ => map_mountain, OO => map_olive,
							   -  => map_path,	   PP => map_pine,
							   ~  => map_river,    #= => map_railway,
							   -- => map_road,	   .. => map_room,
							   ~~ => map_sea,	   || => map_shaft,
							   *  => map_costar,   .: => map_step,
							   () => map_swamp,	   TT => map_forest,
							   [] => map_yard,	   %% => map_blizzard,
							   -_ => map_rockypth, %^ => map_snowymtn,
							   ^% => map_snowymtn');

	setimage(iconid, imageid);
}

updateicons {
	status_index = 0;

	if (weather != 'F')
	{
		oldweather = weather;

		wimage = switch(weather, 'S => snow, B => blizzard, R => rain, T => storm, C => cloudy, O => overcast');
		setimage(('status_' + status_index), wimage);

		wtip = switch(weather, 'S => It\'s snowing!, B => Blizzard!, R => It\'s raining!, T => It\'s stormy!, C => It\'s cloudy!, O => It\'s overcast!');
		settext(('status_' + status_index), wtip);

		status_index++;
	}

	if (blind == 'Y')
	{
		setimage(('status_' + status_index), 'aff_blinded');						
		settext(('status_' + status_index), 'Blinded');
		status_index++;
	}

	if (deaf == 'Y')
	{
		setimage(('status_' + status_index), 'aff_deaf');
		settext(('status_' + status_index), 'Deafened');
		status_index++;
	}

	if (dumb == 'Y')
	{
		setimage(('status_' + status_index), 'aff_dumb');
		settext(('status_' + status_index), 'Dumb');
		status_index++;
	}

	if (crippled == 'Y')
	{
		setimage(('status_' + status_index), 'aff_crippled');
		settext(('status_' + status_index), 'Crippled');
		status_index++;
	}					

	if (status_index == 5)
	{
		showwindow('status_0'); showwindow('status_1'); showwindow('status_2'); showwindow('status_3'); showwindow('status_4');
	}
	else
	{
		if (status_index == 4)
		{
			showwindow('status_0'); showwindow('status_1'); showwindow('status_2'); showwindow('status_3'); hidewindow('status_4');
		}
		else
		{
			if (status_index == 3)
			{
				showwindow('status_0'); showwindow('status_1'); showwindow('status_2'); hidewindow('status_3'); hidewindow('status_4');
			}
			else
			{
				if (status_index == 2)
				{
					showwindow('status_0'); showwindow('status_1'); hidewindow('status_2'); hidewindow('status_3'); hidewindow('status_4');
				}
				else
				{
					if (status_index == 1)
					{
						showwindow('status_0'); hidewindow('status_1'); hidewindow('status_2'); hidewindow('status_3'); hidewindow('status_4');
					}
					else
					{
						hidewindow('status_0'); hidewindow('status_1'); hidewindow('status_2'); hidewindow('status_3'); hidewindow('status_4');
					}
				}
			}
		}
	};
}

updatescore {					
	sc = int(score);
																		
	if (sc != lastscore)
	{												
		settext('score', fstring(sc));

		if ((startscore < 0) && (sc > 0))
			{ startscore = sc; }
										
		if (startscore == sc)
		{
			settextcolour('resetscore', '#ffffff');
			settext('resetscore', '(-)');
		}
		else
		{			
			if (sc > startscore)
			{	
				scdiff = (sc - startscore);	
								
				settextcolour('resetscore', '#77ff77');	
				settext('resetscore', ('(+' + fstring(scdiff) + ')'));								
			}
			else
			{
				scdiff = (startscore - sc);

				settextcolour('resetscore', '#ff7777');	
				settext('resetscore', ('(-' + fstring(scdiff) + ')'));	
			}
		}
						
		lastscore = sc;	
	}
}

updatestatus {
	updatescore();
												
	settext('sta', ('STA: ' + sta) + (' (' + stamax) + ')');
	settext('str', ('STR: ' + effstr) + (' (' + str) + ')');
	settext('dex', ('DEX: ' + effdex) + (' (' + dex) + ')');

	if (mag == 0)
		{ settext('mag', 'MAG: - (-)'); }
	else
		{ settext('mag', ('MAG: ' + mag) + (' (' + magmax) + ')'); }

	updateicons();

	oldsta = sta;													
	sta = ceiling(stamax, sta);

	oldmag = mag;
	mag = ceiling(magmax, mag);
					
	oldstr = str;
	str = floor(effstr, str);

	olddex = dex;
	dex = floor(effdex, dex);

	resetlabel = (string(ttreset) + ' minutes to reset');
	settext('reseticon', resetlabel);
	settext('resetfader', resetlabel);

	ttreset = ceiling(105, ttreset);

	setfaderrange('stafader', stamax);
	setfadervalue('stafader', stamax - sta);
	setfaderrange('magfader', magmax);
	setfadervalue('magfader', magmax - mag);
	setfaderrange('strfader', str);
	setfadervalue('strfader', str - effstr);
	setfaderrange('dexfader', dex);
	setfadervalue('dexfader', dex - effdex);
	setfaderrange('resetfader', 105);
	setfadervalue('resetfader', 105 - ttreset);										
					
	sta = oldsta;
	mag = oldmag;
	str = oldstr;
	dex = olddex;

	considerdreamword();				
}

processfeinv {					
	if (feitext == '========')
		{ feimode='inventory'; }					
	else
	{
		if (feitext == '--')
			{ showwindow('blindedicon'); }
		else
		{
			if (feitext == 'oo')
				{ showwindow('darkicon'); }
			else
				{ appenditem(feimode, feitext); }
		}
	}

	feitext='';					
}